/**
 * Betfair: Exchange Streaming API
 * API to receive streamed updates. This is an ssl socket connection of CRLF delimited json messages (see RequestMessage & ResponseMessage)
 *
 * OpenAPI spec version: 1.0.1423
 * Contact: bdp@betfair.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package com.betfair.esa.swagger.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModelProperty;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;


/**
 * MarketFilter
 */
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2020-07-08T14:44:27.518+08:00")
public class MarketFilter   {
  @SerializedName("countryCodes")
  private List<String> countryCodes = new ArrayList<String>();

  /**
   * Gets or Sets bettingTypes
   */
  public enum BettingTypesEnum {
    @SerializedName("ODDS")
    ODDS("ODDS"),
    
    @SerializedName("LINE")
    LINE("LINE"),
    
    @SerializedName("RANGE")
    RANGE("RANGE"),
    
    @SerializedName("ASIAN_HANDICAP_DOUBLE_LINE")
    ASIAN_HANDICAP_DOUBLE_LINE("ASIAN_HANDICAP_DOUBLE_LINE"),
    
    @SerializedName("ASIAN_HANDICAP_SINGLE_LINE")
    ASIAN_HANDICAP_SINGLE_LINE("ASIAN_HANDICAP_SINGLE_LINE");

    private String value;

    BettingTypesEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
  }

  @SerializedName("bettingTypes")
  private List<BettingTypesEnum> bettingTypes = new ArrayList<BettingTypesEnum>();

  @SerializedName("turnInPlayEnabled")
  private Boolean turnInPlayEnabled = null;

  @SerializedName("marketTypes")
  private List<String> marketTypes = new ArrayList<String>();

  @SerializedName("venues")
  private List<String> venues = new ArrayList<String>();

  @SerializedName("marketIds")
  private List<String> marketIds = new ArrayList<String>();

  @SerializedName("eventTypeIds")
  private List<String> eventTypeIds = new ArrayList<String>();

  @SerializedName("eventIds")
  private List<String> eventIds = new ArrayList<String>();

  @SerializedName("bspMarket")
  private Boolean bspMarket = null;

  @SerializedName("raceTypes")
  private List<String> raceTypes = new ArrayList<String>();

  public MarketFilter countryCodes(List<String> countryCodes) {
    this.countryCodes = countryCodes;
    return this;
  }

  public MarketFilter addCountryCodesItem(String countryCodesItem) {
    this.countryCodes.add(countryCodesItem);
    return this;
  }

   /**
   * Get countryCodes
   * @return countryCodes
  **/
  @ApiModelProperty(example = "null", value = "")
  public List<String> getCountryCodes() {
    return countryCodes;
  }

  public void setCountryCodes(List<String> countryCodes) {
    this.countryCodes = countryCodes;
  }

  public MarketFilter bettingTypes(List<BettingTypesEnum> bettingTypes) {
    this.bettingTypes = bettingTypes;
    return this;
  }

  public MarketFilter addBettingTypesItem(BettingTypesEnum bettingTypesItem) {
    this.bettingTypes.add(bettingTypesItem);
    return this;
  }

   /**
   * Get bettingTypes
   * @return bettingTypes
  **/
  @ApiModelProperty(example = "null", value = "")
  public List<BettingTypesEnum> getBettingTypes() {
    return bettingTypes;
  }

  public void setBettingTypes(List<BettingTypesEnum> bettingTypes) {
    this.bettingTypes = bettingTypes;
  }

  public MarketFilter turnInPlayEnabled(Boolean turnInPlayEnabled) {
    this.turnInPlayEnabled = turnInPlayEnabled;
    return this;
  }

   /**
   * Get turnInPlayEnabled
   * @return turnInPlayEnabled
  **/
  @ApiModelProperty(example = "null", value = "")
  public Boolean getTurnInPlayEnabled() {
    return turnInPlayEnabled;
  }

  public void setTurnInPlayEnabled(Boolean turnInPlayEnabled) {
    this.turnInPlayEnabled = turnInPlayEnabled;
  }

  public MarketFilter marketTypes(List<String> marketTypes) {
    this.marketTypes = marketTypes;
    return this;
  }

  public MarketFilter addMarketTypesItem(String marketTypesItem) {
    this.marketTypes.add(marketTypesItem);
    return this;
  }

   /**
   * Get marketTypes
   * @return marketTypes
  **/
  @ApiModelProperty(example = "null", value = "")
  public List<String> getMarketTypes() {
    return marketTypes;
  }

  public void setMarketTypes(List<String> marketTypes) {
    this.marketTypes = marketTypes;
  }

  public MarketFilter venues(List<String> venues) {
    this.venues = venues;
    return this;
  }

  public MarketFilter addVenuesItem(String venuesItem) {
    this.venues.add(venuesItem);
    return this;
  }

   /**
   * Get venues
   * @return venues
  **/
  @ApiModelProperty(example = "null", value = "")
  public List<String> getVenues() {
    return venues;
  }

  public void setVenues(List<String> venues) {
    this.venues = venues;
  }

  public MarketFilter marketIds(List<String> marketIds) {
    this.marketIds = marketIds;
    return this;
  }

  public MarketFilter addMarketIdsItem(String marketIdsItem) {
    this.marketIds.add(marketIdsItem);
    return this;
  }

   /**
   * Get marketIds
   * @return marketIds
  **/
  @ApiModelProperty(example = "null", value = "")
  public List<String> getMarketIds() {
    return marketIds;
  }

  public void setMarketIds(List<String> marketIds) {
    this.marketIds = marketIds;
  }

  public MarketFilter eventTypeIds(List<String> eventTypeIds) {
    this.eventTypeIds = eventTypeIds;
    return this;
  }

  public MarketFilter addEventTypeIdsItem(String eventTypeIdsItem) {
    this.eventTypeIds.add(eventTypeIdsItem);
    return this;
  }

   /**
   * Get eventTypeIds
   * @return eventTypeIds
  **/
  @ApiModelProperty(example = "null", value = "")
  public List<String> getEventTypeIds() {
    return eventTypeIds;
  }

  public void setEventTypeIds(List<String> eventTypeIds) {
    this.eventTypeIds = eventTypeIds;
  }

  public MarketFilter eventIds(List<String> eventIds) {
    this.eventIds = eventIds;
    return this;
  }

  public MarketFilter addEventIdsItem(String eventIdsItem) {
    this.eventIds.add(eventIdsItem);
    return this;
  }

   /**
   * Get eventIds
   * @return eventIds
  **/
  @ApiModelProperty(example = "null", value = "")
  public List<String> getEventIds() {
    return eventIds;
  }

  public void setEventIds(List<String> eventIds) {
    this.eventIds = eventIds;
  }

  public MarketFilter bspMarket(Boolean bspMarket) {
    this.bspMarket = bspMarket;
    return this;
  }

   /**
   * Get bspMarket
   * @return bspMarket
  **/
  @ApiModelProperty(example = "null", value = "")
  public Boolean getBspMarket() {
    return bspMarket;
  }

  public void setBspMarket(Boolean bspMarket) {
    this.bspMarket = bspMarket;
  }

  public MarketFilter raceTypes(List<String> raceTypes) {
    this.raceTypes = raceTypes;
    return this;
  }

  public MarketFilter addRaceTypesItem(String raceTypesItem) {
    this.raceTypes.add(raceTypesItem);
    return this;
  }

   /**
   * Get raceTypes
   * @return raceTypes
  **/
  @ApiModelProperty(example = "null", value = "")
  public List<String> getRaceTypes() {
    return raceTypes;
  }

  public void setRaceTypes(List<String> raceTypes) {
    this.raceTypes = raceTypes;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    MarketFilter marketFilter = (MarketFilter) o;
    return Objects.equals(this.countryCodes, marketFilter.countryCodes) &&
        Objects.equals(this.bettingTypes, marketFilter.bettingTypes) &&
        Objects.equals(this.turnInPlayEnabled, marketFilter.turnInPlayEnabled) &&
        Objects.equals(this.marketTypes, marketFilter.marketTypes) &&
        Objects.equals(this.venues, marketFilter.venues) &&
        Objects.equals(this.marketIds, marketFilter.marketIds) &&
        Objects.equals(this.eventTypeIds, marketFilter.eventTypeIds) &&
        Objects.equals(this.eventIds, marketFilter.eventIds) &&
        Objects.equals(this.bspMarket, marketFilter.bspMarket) &&
        Objects.equals(this.raceTypes, marketFilter.raceTypes);
  }

  @Override
  public int hashCode() {
    return Objects.hash(countryCodes, bettingTypes, turnInPlayEnabled, marketTypes, venues, marketIds, eventTypeIds, eventIds, bspMarket, raceTypes);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class MarketFilter {\n");
    
    sb.append("    countryCodes: ").append(toIndentedString(countryCodes)).append("\n");
    sb.append("    bettingTypes: ").append(toIndentedString(bettingTypes)).append("\n");
    sb.append("    turnInPlayEnabled: ").append(toIndentedString(turnInPlayEnabled)).append("\n");
    sb.append("    marketTypes: ").append(toIndentedString(marketTypes)).append("\n");
    sb.append("    venues: ").append(toIndentedString(venues)).append("\n");
    sb.append("    marketIds: ").append(toIndentedString(marketIds)).append("\n");
    sb.append("    eventTypeIds: ").append(toIndentedString(eventTypeIds)).append("\n");
    sb.append("    eventIds: ").append(toIndentedString(eventIds)).append("\n");
    sb.append("    bspMarket: ").append(toIndentedString(bspMarket)).append("\n");
    sb.append("    raceTypes: ").append(toIndentedString(raceTypes)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

